CREATE SEQUENCE kesziteslista_kod_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE SEQUENCE kesziteslista_fej_kod_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE TABLE kesziteslista_fej
(
  partner_kod integer NOT NULL,
  mozgasnem_kod integer NOT NULL,
  datum date NOT NULL DEFAULT '2005-01-01',
  ido time without time zone DEFAULT '00:00:00',
  bizonylatszam character varying(30) DEFAULT '',
  m_userid character varying(20) DEFAULT '',
  m_date date DEFAULT '2005-01-01',
  m_time time without time zone DEFAULT '00:00:00',
  c_userid character varying(20) DEFAULT '',
  c_date date DEFAULT '2005-01-01',
  c_time time without time zone DEFAULT '00:00:00',
  raktar_mozgas_bizonylat character(20) NOT NULL,
  deviza_nev character(4),
  deviza_arfolyam real,
  telj_datum date,
  fiz_hatarido date,
  fizetesmod_kod integer,
  atvevo_kod integer,
  bizonylat_fajta integer DEFAULT 1,
  kelte date,
  netto_vegosszeg double precision,
  brutto_vegosszeg double precision,
  netto_vegosszeg_huf double precision,
  brutto_vegosszeg_huf double precision,
  netto_arbevetel_vegosszeg double precision,
  netto_arbevetel_vegosszeg_huf double precision,
  netto_kedvezmeny double precision,
  netto_kedvezmeny_huf double precision,
  brutto_arbevetel_vegosszeg double precision,
  brutto_arbevetel_vegosszeg_huf double precision,
  sztornozott_bizonylat character varying(12),
  sztornozo_bizonylat character varying(12),
  megjegyzes text DEFAULT '',
  kod integer NOT NULL DEFAULT nextval('public.kesziteslista_fej_kod_seq'),
  sztornozott_bizonylat_kod integer DEFAULT 0,
  sztornozo_bizonylat_kod integer DEFAULT 0,
  CONSTRAINT kesziteslista_fej_pkey PRIMARY KEY (kod)
) 
WITH OIDS;

CREATE TABLE kesziteslista
(
  kod integer NOT NULL DEFAULT nextval('public.kesziteslista_kod_seq'),
  tetel_kod integer NOT NULL,
  forras_raktar_kod integer NOT NULL,
  mennyiseg double precision NOT NULL DEFAULT (0),
  cel_raktar_kod integer,
  cel_raktar_ujkeszlet double precision,
  raktar_mozgas_bizonylat character(20),
  forras_raktar_ujkeszlet integer,
  afakulcs integer,
  netto_osszeg double precision,
  brutto_osszeg double precision,
  netto_osszeg_huf double precision,
  brutto_osszeg_huf double precision,
  netto_arbevetel double precision,
  netto_kedvezmeny double precision,
  netto_kedvezmeny_huf double precision,
  netto_arbevetel_huf double precision,
  brutto_arbevetel_huf double precision,
  brutto_arbevetel double precision,
  tetel_tipus smallint,
  megjegyzes text,
  netto_egysegar double precision,
  brutto_egysegar double precision,
  brutto_egysegar_huf double precision,
  netto_egysegar_huf double precision,
  mennyiseg_szamlazva double precision DEFAULT (0),
  szallito_szama character varying(20) DEFAULT '',
  szallitos_tetel_kod integer,
  csak_fobizonylat_tetel smallint,
  fej_kod integer,
  CONSTRAINT kesziteslista_pkey PRIMARY KEY (kod)
) 
WITH OIDS;



update mozgasnem
   set bizonylat_kapcsolat = 0
 where bizonylat_kapcsolat is null;

alter table mozgasnem
   alter column bizonylat_kapcsolat set not null;


alter table raktar_mozgas_fej
  add forras_raktar_kod int4;

alter table raktar_mozgas_fej
  add cel_raktar_kod int4;

alter table raktar_mozgas_fej
  add constraint raktar_mozgas_fej_fk5 foreign key (forras_raktar_kod) references raktar_nevek (kod);

alter table raktar_mozgas_fej
  add constraint raktar_mozgas_fej_fk6 foreign key (cel_raktar_kod) references raktar_nevek (kod);


update raktar_mozgas_fej
   set forras_raktar_kod =
(select m.forras_raktar
   from mozgasnem m
  where m.kod = raktar_mozgas_fej.mozgasnem_kod);

update raktar_mozgas_fej
   set cel_raktar_kod =
(select m.cel_raktar
   from mozgasnem m
  where m.kod = raktar_mozgas_fej.mozgasnem_kod);

ALTER TABLE kesziteslista_fej ADD COLUMN forras_raktar_kod integer;
ALTER TABLE kesziteslista_fej ALTER COLUMN forras_raktar_kod SET STORAGE PLAIN;
ALTER TABLE kesziteslista_fej ADD COLUMN cel_raktar_kod integer;
ALTER TABLE kesziteslista_fej ALTER COLUMN cel_raktar_kod SET STORAGE PLAIN;