DROP TABLE _cimke;

CREATE TABLE _cimke
(
  kod serial NOT NULL,
  fej_kod integer DEFAULT 0,
  visible integer DEFAULT 0,
  objecttype character(20),
  fieldname character(100),
  fontname character(100),
  fontsize integer DEFAULT 0,
  fontbold integer DEFAULT 0,
  fontitalic integer DEFAULT 0,
  fontunderline integer DEFAULT 0,
  fontstrikeout integer DEFAULT 0,
  leftposition numeric(10,2) DEFAULT 0,
  topposition numeric(10,2) DEFAULT 0,
  width numeric(10,2) DEFAULT 0,
  height numeric(10,2) DEFAULT 0,
  barcodetype character(100),
  statictext character(250),
  alignment character(20),
  autosize integer DEFAULT 0,
  picture bytea,
  CONSTRAINT _cimke_pkey PRIMARY KEY (kod)
)
WITHOUT OIDS;

DROP TABLE _cimke_fej;

CREATE TABLE _cimke_fej
(
  kod serial NOT NULL,
  pageheight numeric(10,2) DEFAULT 0,
  pagewidth numeric(10,2) DEFAULT 0,
  labelheight numeric(10,2) DEFAULT 0,
  labelwidth numeric(10,2) DEFAULT 0,
  topmargin numeric(10,2) DEFAULT 0,
  bottommargin numeric(10,2) DEFAULT 0,
  leftmargin numeric(10,2) DEFAULT 0,
  rightmargin numeric(10,2) DEFAULT 0,
  labelverticalspace numeric(10,2) DEFAULT 0,
  labelhorizontalspace numeric(10,2) DEFAULT 0,
  columns integer DEFAULT 0,
  "name" character(200),
  CONSTRAINT _cimke_fej_pkey PRIMARY KEY (kod)
)
WITHOUT OIDS;


-- Index: _cimke_fej_name

-- DROP INDEX _cimke_fej_name;

CREATE INDEX _cimke_fej_name
  ON _cimke_fej
  USING btree
  (name);