CREATE OR REPLACE FUNCTION tr_raktar_mozgas_atlagar()
  RETURNS trigger AS
'declare

  v_atl_mennyiseg     tetel_raktar.atl_mennyiseg%type;
  v_atl_atlagar       tetel_raktar.atl_atlagar%type;
  v_uj_atlagar        tetel_raktar.atl_atlagar%type;
  v_netto_osszeg_huf  raktar_mozgas.netto_osszeg_huf%type;
  v_partner_kod       raktar_mozgas_fej.partner_kod%type;
  v_db                integer;
  v_foglalt           real;
  v_foglalt_valtozas  real;
  v_rendelt           real;
  v_rendelt_valtozas  real;
begin
  -- Ha nem keszletet mozgatunk, akkor semmit sem kell tenni
  if new.csak_fobizonylat_tetel = ''1'' then
     if new.tetel_tipus = ''0'' then
        select utolsobeszerzesiar
          into v_atl_atlagar
          from tetel
         where kod = new.tetel_kod;
        new.forras_raktar_atlagar:=v_atl_atlagar;
     end if;
     return new;
  end if;

  -- Foglalas
  IF new.csak_fobizonylat_tetel = ''2'' THEN
     IF new.tetel_tipus = ''1'' THEN
        IF new.forras_raktar_kod<>0 THEN
           SELECT partner_kod
             INTO v_partner_kod
             FROM raktar_mozgas_fej
             WHERE kod = new.fej_kod;
             
           UPDATE tetel_raktar
             SET foglalt = foglalt + new.mennyiseg,
                 szabad = keszlet - new.mennyiseg - foglalt
             WHERE raktar_kod = new.forras_raktar_kod
               AND tetel_kod = new.tetel_kod;

           SELECT count(*)
             INTO v_db
             FROM tetel_foglalas
            WHERE partner_kod = v_partner_kod
              AND raktar_kod = new.forras_raktar_kod
              AND tetel_kod = new.tetel_kod;   

           IF v_db = 0 THEN
              INSERT INTO tetel_foglalas (partner_kod,raktar_kod,tetel_kod,foglalt) VALUES
                                         (v_partner_kod,new.forras_raktar_kod,new.tetel_kod,new.mennyiseg);
           ELSE
              UPDATE tetel_foglalas
                 SET foglalt = foglalt + new.mennyiseg
               WHERE partner_kod = v_partner_kod
                 AND raktar_kod = new.forras_raktar_kod
                 AND tetel_kod = new.tetel_kod;             
           END IF;             
        END IF;
     END IF;
     RETURN new;
  END IF;

 -- Rendels
  IF new.csak_fobizonylat_tetel = ''3'' THEN
     IF (new.tetel_tipus <> ''0'') AND (new.tetel_tipus <> ''8'') THEN
        IF new.forras_raktar_kod<>0 THEN
           SELECT partner_kod
             INTO v_partner_kod
             FROM raktar_mozgas_fej
             WHERE kod = new.fej_kod;
             
           UPDATE tetel_raktar
             SET rendelt = rendelt + new.mennyiseg
             WHERE raktar_kod = new.forras_raktar_kod
               AND tetel_kod = new.tetel_kod;

           SELECT count(*)
             INTO v_db
             FROM tetel_rendeles
            WHERE partner_kod = v_partner_kod
              AND raktar_kod = new.forras_raktar_kod
              AND tetel_kod = new.tetel_kod;   

           IF v_db = 0 THEN
              INSERT INTO tetel_rendeles (partner_kod,raktar_kod,tetel_kod,rendelt) VALUES
                                         (v_partner_kod,new.forras_raktar_kod,new.tetel_kod,new.mennyiseg);
           ELSE
              UPDATE tetel_rendeles
                 SET rendelt = rendelt + new.mennyiseg
               WHERE partner_kod = v_partner_kod
                 AND raktar_kod = new.forras_raktar_kod
                 AND tetel_kod = new.tetel_kod;             
           END IF;             
        END IF;
     END IF;
     RETURN new;
  END IF;  

  -- Keszletet erinto mozgas

  if new.forras_raktar_kod<>0 then

     update tetel_raktar
        set keszlet = keszlet - new.mennyiseg,
            szabad = keszlet - new.mennyiseg - foglalt,
            atl_mennyiseg = atl_mennyiseg - new.mennyiseg
      where raktar_kod = new.forras_raktar_kod
        and tetel_kod = new.tetel_kod;

     select atl_mennyiseg,
            atl_atlagar
       into v_atl_mennyiseg,
            v_atl_atlagar
       from tetel_raktar
      where raktar_kod = new.forras_raktar_kod
        and tetel_kod = new.tetel_kod;

     new.forras_raktar_ujkeszlet:=v_atl_mennyiseg;
     new.forras_raktar_atlagar:=v_atl_atlagar;

     if new.cel_raktar_kod=0 then -- visszaigazolt tetel kiszallitasa
        SELECT partner_kod
          INTO v_partner_kod
          FROM raktar_mozgas_fej
         WHERE kod = new.fej_kod;

        SELECT foglalt
          INTO v_foglalt
          FROM tetel_foglalas
         WHERE partner_kod = v_partner_kod
           AND raktar_kod = new.forras_raktar_kod
           AND tetel_kod = new.tetel_kod;   

         IF (v_foglalt <> 0) THEN
            IF (new.mennyiseg > v_foglalt) THEN 
               v_foglalt_valtozas := v_foglalt;
            ELSE
               v_foglalt_valtozas := new.mennyiseg;
            END IF;

            UPDATE tetel_foglalas
               SET foglalt = foglalt - v_foglalt_valtozas
             WHERE partner_kod = v_partner_kod
               AND raktar_kod = new.forras_raktar_kod
               AND tetel_kod = new.tetel_kod;

	    UPDATE tetel_raktar
	       SET foglalt = foglalt - v_foglalt_valtozas, szabad = keszlet - v_foglalt_valtozas - foglalt
	     WHERE raktar_kod = new.forras_raktar_kod AND tetel_kod = new.tetel_kod;               
         END IF;

     end if;
  end if;

  if new.cel_raktar_kod<>0 then
        
     v_netto_osszeg_huf:=new.netto_osszeg_huf;

     if v_netto_osszeg_huf = 0 then
           
        select atl_atlagar * new.mennyiseg
          into v_netto_osszeg_huf
          from tetel_raktar
         where raktar_kod = new.forras_raktar_kod
           and tetel_kod = new.tetel_kod;
     end if;

     select atl_mennyiseg,
            atl_atlagar
       into v_atl_mennyiseg,
            v_atl_atlagar
       from tetel_raktar
      where raktar_kod = new.cel_raktar_kod
        and tetel_kod = new.tetel_kod;

     if v_atl_mennyiseg + new.mennyiseg<>0 then
        v_uj_atlagar:=((v_atl_mennyiseg * v_atl_atlagar) + v_netto_osszeg_huf) / (v_atl_mennyiseg + new.mennyiseg);
     else
        -- v_uj_atlagar:=0;
     end if;

     update tetel_raktar
        set keszlet = keszlet + new.mennyiseg,
            szabad = keszlet + new.mennyiseg - foglalt,
            atl_mennyiseg = atl_mennyiseg + new.mennyiseg,
            atl_atlagar = v_uj_atlagar
      where raktar_kod = new.cel_raktar_kod
        and tetel_kod = new.tetel_kod;

     new.cel_raktar_ujkeszlet:=v_atl_mennyiseg + new.mennyiseg;
     new.cel_raktar_atlagar:=v_uj_atlagar;

     if new.forras_raktar_kod=0 then -- rendelesre erkezo tetel bevetelezese
        SELECT partner_kod
          INTO v_partner_kod
          FROM raktar_mozgas_fej
         WHERE kod = new.fej_kod;

        SELECT rendelt
          INTO v_rendelt
          FROM tetel_rendeles
         WHERE partner_kod = v_partner_kod
           AND raktar_kod = new.cel_raktar_kod
           AND tetel_kod = new.tetel_kod;   

         IF (v_rendelt <> 0) THEN
            IF (new.mennyiseg > v_rendelt) THEN 
               v_rendelt_valtozas := v_rendelt;
            ELSE
               v_rendelt_valtozas := new.mennyiseg;
            END IF;

            UPDATE tetel_rendeles
               SET rendelt = rendelt - v_rendelt_valtozas
             WHERE partner_kod = v_partner_kod
               AND raktar_kod = new.cel_raktar_kod
               AND tetel_kod = new.tetel_kod;             

            UPDATE tetel_raktar
	       SET rendelt = rendelt - v_rendelt_valtozas
	     WHERE raktar_kod = new.cel_raktar_kod 
	       AND tetel_kod = new.tetel_kod;
         END IF;

     end if;
     
  end if;

  return new;
end;'
  LANGUAGE plpgsql VOLATILE
  COST 100;


CREATE OR REPLACE FUNCTION tr_raktar_mozgas_egyedi()
  RETURNS trigger AS
'declare

  v_forras_raktar_kod raktar_mozgas_fej.forras_raktar_kod%type;
  v_cel_raktar_kod    raktar_mozgas_fej.cel_raktar_kod%type;
  v_tetel_kod         raktar_mozgas.tetel_kod%type;
  v_mennyiseg         tetel_raktar_egyedi.mennyiseg%type;
  v_db                integer;

begin
  if (new.csak_fobizonylat_tetel >= 1) then
     return new;  
  end if;

     -- Bizonylat adatainak meghatarozasa
     select rf.forras_raktar_kod,
            rf.cel_raktar_kod,
            rt.tetel_kod
       into v_forras_raktar_kod,
            v_cel_raktar_kod,
            v_tetel_kod
       from raktar_mozgas_fej rf,
            raktar_mozgas rt
      where rf.kod = rt.fej_kod
        and rt.kod = new.rm_kod;

     -- Forras raktar kezelese
     if v_forras_raktar_kod<>0 then

        select count(*)
          into v_db
          from tetel_raktar_egyedi
         where raktar_kod = v_forras_raktar_kod
           and tetel_kod = v_tetel_kod
           and egyedi_azonosito_kod = new.egyedi_azonosito_kod;

        if v_db = 0 then

           insert into tetel_raktar_egyedi
           (raktar_kod,
            tetel_kod,
            egyedi_azonosito_kod,
            mennyiseg,
            foglalt,
            szabad)

            values

           (v_forras_raktar_kod,
           v_tetel_kod,
           new.egyedi_azonosito_kod,
           - new.mennyiseg,
           0,
           - new.mennyiseg);
        
        else
     
           update tetel_raktar_egyedi
             set mennyiseg = mennyiseg - new.mennyiseg,
                 szabad = szabad - new.mennyiseg
             where raktar_kod = v_forras_raktar_kod
               and tetel_kod = v_tetel_kod
               and egyedi_azonosito_kod = new.egyedi_azonosito_kod;
        end if;

        select mennyiseg
          into v_mennyiseg
          from tetel_raktar_egyedi
         where raktar_kod = v_forras_raktar_kod
           and tetel_kod = v_tetel_kod
           and egyedi_azonosito_kod = new.egyedi_azonosito_kod;

        if v_mennyiseg = 0 then

           delete from tetel_raktar_egyedi
            where raktar_kod = v_forras_raktar_kod
              and tetel_kod = v_tetel_kod
              and egyedi_azonosito_kod = new.egyedi_azonosito_kod;
        end if;
     end if;


     -- Cel raktar kezelese
     if v_cel_raktar_kod<>0 then
  
        select count(*)
          into v_db
          from tetel_raktar_egyedi
         where raktar_kod = v_cel_raktar_kod
           and tetel_kod = v_tetel_kod
           and egyedi_azonosito_kod = new.egyedi_azonosito_kod;

        if v_db = 0 then

          insert into tetel_raktar_egyedi
          (raktar_kod,
           tetel_kod,
           egyedi_azonosito_kod,
           mennyiseg,
           foglalt,
           szabad)

          values

          (v_cel_raktar_kod,
           v_tetel_kod,
           new.egyedi_azonosito_kod,
           new.mennyiseg,
           0,
           new.mennyiseg);
        
        else
     
          update tetel_raktar_egyedi
             set mennyiseg = mennyiseg + new.mennyiseg,
                 szabad = szabad + new.mennyiseg
           where raktar_kod = v_cel_raktar_kod
             and tetel_kod = v_tetel_kod
             and egyedi_azonosito_kod = new.egyedi_azonosito_kod;
        end if;

        select mennyiseg
          into v_mennyiseg
          from tetel_raktar_egyedi
         where raktar_kod = v_cel_raktar_kod
           and tetel_kod = v_tetel_kod
           and egyedi_azonosito_kod = new.egyedi_azonosito_kod;

        if v_mennyiseg = 0 then

           delete from tetel_raktar_egyedi
            where raktar_kod = v_cel_raktar_kod
              and tetel_kod = v_tetel_kod
              and egyedi_azonosito_kod = new.egyedi_azonosito_kod;
        end if;
     end if;

     return new;  
  
  
end;'
  LANGUAGE plpgsql VOLATILE
  COST 100;



CREATE OR REPLACE FUNCTION tr_raktar_mozgas_fifo()
  RETURNS trigger AS
'-- Verzio: V2.01 2009.02.10.

declare

  v_forras_raktar_fifo_ar raktar_mozgas.forras_raktar_fifo_ar%type;
  v_cel_raktar_fifo_ar    raktar_mozgas.cel_raktar_fifo_ar%type;
  v_mennyiseg             raktar_mozgas.mennyiseg%type;

begin
  -- Ha nem keszletet mozgatunk, akkor azt specialisan kell kezelni
  if (new.csak_fobizonylat_tetel >= 1) then

    if new.szallitos_tetel_kod is not null then

      select forras_raktar_fifo_ar,
             cel_raktar_fifo_ar
        into v_forras_raktar_fifo_ar,
             v_cel_raktar_fifo_ar
        from raktar_mozgas
       where kod = new.szallitos_tetel_kod;

       new.forras_raktar_fifo_ar:=v_forras_raktar_fifo_ar;
       new.forras_raktar_fifo_ertek:=v_forras_raktar_fifo_ar * v_mennyiseg;

       new.cel_raktar_fifo_ar:=v_cel_raktar_fifo_ar;
       new.cel_raktar_fifo_ertek:=v_cel_raktar_fifo_ar * v_mennyiseg;       
    end if;
    
  -- Keszletet erinto mozgas
  else  
    perform fifo_tetel(new.tetel_kod);
  end if;
  
  return new;
end;'
  LANGUAGE plpgsql VOLATILE
  COST 100;

CREATE OR REPLACE FUNCTION fifo_tetel(p_tetel_kod integer)
  RETURNS boolean AS
'declare

v_tetel_kod                 tetel.kod%type;

v_work_sorszam              integer;

v_datum                     raktar_mozgas_fej.datum%type;
v_ido                       raktar_mozgas_fej.ido%type;
v_sztornozo_bizonylat_kod   raktar_mozgas_fej.sztornozo_bizonylat_kod%type;
v_sztornozott_bizonylat_kod raktar_mozgas_fej.sztornozott_bizonylat_kod%type;
v_kod                       raktar_mozgas.kod%type;
v_forras_raktar_kod         raktar_mozgas.forras_raktar_kod%type;
v_cel_raktar_kod            raktar_mozgas.cel_raktar_kod%type;
v_work_raktar_kod           raktar_mozgas.forras_raktar_kod%type;
v_mennyiseg                 raktar_mozgas.mennyiseg%type;
v_work_mennyiseg            raktar_mozgas.mennyiseg%type;
v_netto_osszeg_huf          raktar_mozgas.netto_osszeg_huf%type;

v_szt_mennyiseg             raktar_mozgas.mennyiseg%type;
v_szt_netto_osszeg_huf      raktar_mozgas.netto_osszeg_huf%type;

v_sorszam                   tetel_raktar_fifo.sorszam%type;
v_beszerzes                 tetel_raktar_fifo.beszerzes%type;
v_beszerzes_ertek           tetel_raktar_fifo.beszerzes_ertek%type;
v_maradek                   tetel_raktar_fifo.maradek%type;

v_ertek                     double precision;

v_update                    char;

v_max_sorszam               tetel_raktar_fifo.sorszam%type;
v_utolsobeszerzesiar        tetel.utolsobeszerzesiar%type;


c_forgalom cursor for

select rf.datum,
       rf.ido,
       rf.sztornozo_bizonylat_kod,
       rf.sztornozott_bizonylat_kod,
       rt.kod,
       rt.forras_raktar_kod,
       rt.cel_raktar_kod,
       rt.mennyiseg,
       rt.netto_osszeg_huf
  from raktar_mozgas_fej rf,
       raktar_mozgas rt
 where rf.kod = rt.fej_kod
   and rt.tetel_kod = v_tetel_kod
   and rt.csak_fobizonylat_tetel<1
 order by rf.datum,
       rf.ido,
       rt.kod;


c_beszerzesek cursor for

select sorszam,
       beszerzes,
       beszerzes_ertek,
       maradek
  from tetel_raktar_fifo
 where tetel_kod = v_tetel_kod
   and raktar_kod = v_work_raktar_kod
   and maradek>0 
 order by sorszam;


begin
  v_tetel_kod:=$1;

  -- Regi adatok torlese
  delete from tetel_raktar_fifo
   where tetel_kod = v_tetel_kod;  

  update raktar_mozgas
     set forras_raktar_fifo_ertek = null,
         forras_raktar_fifo_ar = null,
         cel_raktar_fifo_ertek = null,
         cel_raktar_fifo_ar = null
   where tetel_kod = v_tetel_kod;

  -- Az adott cikk forgalmanak feldolgozasa

  v_work_sorszam:=1;
  
  open c_forgalom;

  fetch c_forgalom
   into v_datum,
        v_ido,
        v_sztornozo_bizonylat_kod,
        v_sztornozott_bizonylat_kod,
        v_kod,
        v_forras_raktar_kod,
        v_cel_raktar_kod,
        v_mennyiseg,
        v_netto_osszeg_huf;

  while found loop

    v_ertek:=0;

    -- Kiadas, ez szandekosan az elso lepes!

    if (v_forras_raktar_kod<>0 and v_mennyiseg>0) or 
       (v_cel_raktar_kod<>0    and v_mennyiseg<0) then

      if v_forras_raktar_kod<>0 and v_mennyiseg>0 then
        v_work_raktar_kod:=v_forras_raktar_kod;
        v_update:=''F'';
      else
        v_work_raktar_kod:=v_cel_raktar_kod;
        v_update:=''C'';
      end if;

      -- A sztornozo es sztornozott bizonylatokat kihagyjuk a szamitasbol
      if v_sztornozo_bizonylat_kod = 0 and
         v_sztornozott_bizonylat_kod = 0 then

        v_work_mennyiseg:=abs(v_mennyiseg);
        
        open c_beszerzesek;

        fetch c_beszerzesek
         into v_sorszam,
              v_beszerzes,
              v_beszerzes_ertek,
              v_maradek;

        while found and v_work_mennyiseg>0 loop

          if v_maradek<=v_work_mennyiseg then

            update tetel_raktar_fifo
               set maradek = 0
             where sorszam = v_sorszam
               and tetel_kod = v_tetel_kod;

            v_ertek:=v_ertek + (v_maradek/v_beszerzes) * v_beszerzes_ertek;
            v_work_mennyiseg:=v_work_mennyiseg - v_maradek;            

          else

            update tetel_raktar_fifo
               set maradek = maradek - v_work_mennyiseg
             where sorszam = v_sorszam
               and tetel_kod = v_tetel_kod;

            v_ertek:=v_ertek + (v_work_mennyiseg/v_beszerzes) * v_beszerzes_ertek;
            v_work_mennyiseg:=0;
            
          end if;
        
          fetch c_beszerzesek
           into v_sorszam,
                v_beszerzes,
                v_beszerzes_ertek,
                v_maradek;
              
        end loop;

        close c_beszerzesek;

        -- Ertek visszairasa
        if v_update = ''F'' then

          update raktar_mozgas
             set forras_raktar_fifo_ertek = v_ertek * sign(v_mennyiseg),
                 forras_raktar_fifo_ar = v_ertek  * sign(v_mennyiseg) / mennyiseg
           where kod = v_kod;
           
        else

          update raktar_mozgas
             set cel_raktar_fifo_ertek = v_ertek * sign(v_mennyiseg),
                 cel_raktar_fifo_ar = v_ertek * sign(v_mennyiseg) / mennyiseg
           where kod = v_kod;

        end if;

        if v_work_mennyiseg<>0 then
          raise exception ''Nincs eleg beszerzes! (tetel_kod:% Munka mennyisg:% Maradk:% Forrs raktr kd:% Clraktr kd:% Mennyisg:% Md:%)'',v_tetel_kod,v_work_mennyiseg,v_maradek, v_forras_raktar_kod, v_cel_raktar_kod, v_mennyiseg, v_update;
        end if;
      end if;

    end if;


    -- Beszerzes
    
    if (v_cel_raktar_kod<>0 and v_mennyiseg>0) then
    
      -- A sztornozo es sztornozott bizonylatokat kihagyjuk a szamitasbol
      if v_sztornozo_bizonylat_kod = 0 and
         v_sztornozott_bizonylat_kod = 0 then

        v_work_mennyiseg:=abs(v_mennyiseg);

        if v_netto_osszeg_huf<>0 then
          v_ertek:=v_netto_osszeg_huf;
        end if;
         
        update tetel_raktar_fifo
           set beszerzes = beszerzes + v_work_mennyiseg,
               beszerzes_ertek = beszerzes_ertek + v_ertek,
               maradek = maradek + v_work_mennyiseg
         where tetel_kod = v_tetel_kod
           and raktar_kod = v_cel_raktar_kod
           and datum = v_datum
           and ido = v_ido;

        if not found then

          insert into tetel_raktar_fifo
          (sorszam,
           tetel_kod,
           raktar_kod,
           datum,
           ido,         
           beszerzes,
           beszerzes_ertek,
           maradek)

          values
      
          (v_work_sorszam,
           v_tetel_kod,
           v_cel_raktar_kod,
           v_datum,
           v_ido,
           v_work_mennyiseg,
           v_ertek,
           v_work_mennyiseg);

          v_work_sorszam:=v_work_sorszam + 1;
        end if;

        -- Ertek visszairasa
        update raktar_mozgas
           set cel_raktar_fifo_ertek = v_ertek * sign(v_mennyiseg),
               cel_raktar_fifo_ar = v_ertek * sign(v_mennyiseg) / mennyiseg
         where kod = v_kod;
      end if;

    end if;


    -- Ez is beszerzes, de maskeppen kell kezelni

    if (v_forras_raktar_kod<>0 and v_mennyiseg<0) then

      -- A sztornozo es sztornozott bizonylatokat kihagyjuk a szamitasbol
      if v_sztornozo_bizonylat_kod = 0 and
         v_sztornozott_bizonylat_kod = 0 then

        v_work_mennyiseg:=abs(v_mennyiseg);

        select max(sorszam)
          into v_max_sorszam
          from tetel_raktar_fifo
         where tetel_kod = p_tetel_kod
           and raktar_kod = v_forras_raktar_kod;

        -- Ha nem volt utolso beszerzes, akkor vegyuk az utolso beszerzesi arat
        if not found or v_max_sorszam is null then

          select utolsobeszerzesiar
            into v_utolsobeszerzesiar
            from tetel
           where kod = p_tetel_kod;

          v_ertek:=v_utolsobeszerzesiar * v_work_mennyiseg;

          insert into tetel_raktar_fifo
          (sorszam,
           tetel_kod,
           raktar_kod,
           datum,
           ido,         
           beszerzes,
           beszerzes_ertek,
           maradek)

          values
      
          (v_work_sorszam,
           v_tetel_kod,
           v_forras_raktar_kod,
           v_datum,
           v_ido,
           v_work_mennyiseg,
           v_ertek,
           v_work_mennyiseg);

          v_work_sorszam:=v_work_sorszam + 1;

          update raktar_mozgas
             set forras_raktar_fifo_ertek = v_ertek,
                 forras_raktar_fifo_ar = v_utolsobeszerzesiar
           where kod = v_kod;

        -- Ha volt utolso beszerzes, akkor vegyuk azt
        else
        
          select beszerzes,
                 beszerzes_ertek
            into v_beszerzes,
                 v_beszerzes_ertek
            from tetel_raktar_fifo
           where tetel_kod = p_tetel_kod
             and sorszam = v_max_sorszam;

          update tetel_raktar_fifo
             set beszerzes = beszerzes + v_work_mennyiseg,
                 beszerzes_ertek = beszerzes_ertek + v_work_mennyiseg * (v_beszerzes_ertek / v_beszerzes),
                 maradek = maradek + v_work_mennyiseg
           where tetel_kod = p_tetel_kod
             and sorszam = v_max_sorszam;        

          update raktar_mozgas
             set forras_raktar_fifo_ertek = v_work_mennyiseg * (v_beszerzes_ertek / v_beszerzes),
                 forras_raktar_fifo_ar = v_beszerzes_ertek / v_beszerzes
           where kod = v_kod;
        end if;
      end if;
    end if;

    -- Kovetkezo tetel
    fetch c_forgalom
     into v_datum,
          v_ido,
          v_sztornozo_bizonylat_kod,
          v_sztornozott_bizonylat_kod,
          v_kod,
          v_forras_raktar_kod,
          v_cel_raktar_kod,
          v_mennyiseg,
          v_netto_osszeg_huf;
  end loop;

  close c_forgalom;

  return true;
end;'
  LANGUAGE plpgsql VOLATILE
  COST 100;


CREATE OR REPLACE FUNCTION atlagar_tetel(integer)
  RETURNS boolean AS
'declare

v_tetel_kod int4;

 
-- c_forgalom
c_forgalom cursor for

select rt.kod,
       rt.forras_raktar_kod,
       rt.cel_raktar_kod,
       rt.mennyiseg,
       rt.netto_osszeg_huf
  from raktar_mozgas_fej rf,
       raktar_mozgas rt
 where rf.kod = rt.fej_kod
   and rt.tetel_kod = v_tetel_kod
   and rt.csak_fobizonylat_tetel<1
 order by rf.datum,
       rf.ido,
       rt.kod;

v_kod               raktar_mozgas.kod%type;
v_forras_raktar_kod raktar_mozgas.forras_raktar_kod%type;
v_cel_raktar_kod    raktar_mozgas.cel_raktar_kod%type;
v_mennyiseg         raktar_mozgas.mennyiseg%type;
v_netto_osszeg_huf  raktar_mozgas.netto_osszeg_huf%type;

v_atl_mennyiseg     tetel_raktar.atl_mennyiseg%type;
v_atl_atlagar       tetel_raktar.atl_atlagar%type;
v_uj_atlagar        tetel_raktar.atl_atlagar%type;


begin
  v_tetel_kod:=$1;

  update tetel_raktar
     set atl_mennyiseg = 0,
         atl_atlagar = 0
   where tetel_kod = v_tetel_kod;

  open c_forgalom;

    fetch c_forgalom
     into v_kod,
          v_forras_raktar_kod,
          v_cel_raktar_kod,
          v_mennyiseg,
          v_netto_osszeg_huf;

    while found loop
      
      if v_forras_raktar_kod<>0 then

        update tetel_raktar
           set atl_mennyiseg = atl_mennyiseg - v_mennyiseg
         where raktar_kod = v_forras_raktar_kod
           and tetel_kod = v_tetel_kod;

        select atl_mennyiseg,
               atl_atlagar
          into v_atl_mennyiseg,
               v_atl_atlagar
          from tetel_raktar
         where raktar_kod = v_forras_raktar_kod
           and tetel_kod = v_tetel_kod;

        update raktar_mozgas
           set forras_raktar_ujkeszlet = v_atl_mennyiseg,
               forras_raktar_atlagar = v_atl_atlagar
         where kod = v_kod
           and (forras_raktar_ujkeszlet<>v_atl_mennyiseg or forras_raktar_atlagar<>v_atl_atlagar or
                forras_raktar_ujkeszlet is null or forras_raktar_atlagar is null);
      end if;

      if v_cel_raktar_kod<>0 then

        if v_netto_osszeg_huf = 0 then
           
           select atl_atlagar * v_mennyiseg
             into v_netto_osszeg_huf
             from tetel_raktar
            where raktar_kod = v_forras_raktar_kod
              and tetel_kod = v_tetel_kod;
        end if;

        select atl_mennyiseg,
               atl_atlagar
          into v_atl_mennyiseg,
               v_atl_atlagar
          from tetel_raktar
         where raktar_kod = v_cel_raktar_kod
           and tetel_kod = v_tetel_kod;

        if v_atl_mennyiseg + v_mennyiseg<>0 then
           v_uj_atlagar:=((v_atl_mennyiseg * v_atl_atlagar) + v_netto_osszeg_huf) / (v_atl_mennyiseg + v_mennyiseg);
        else
           -- v_uj_atlagar:=0;
        end if;        

        update tetel_raktar
           set atl_mennyiseg = atl_mennyiseg + v_mennyiseg,
               atl_atlagar = v_uj_atlagar
         where raktar_kod = v_cel_raktar_kod
           and tetel_kod = v_tetel_kod;

        update raktar_mozgas
           set cel_raktar_ujkeszlet = v_atl_mennyiseg + v_mennyiseg,
               cel_raktar_atlagar = v_uj_atlagar
         where kod = v_kod
           and (cel_raktar_ujkeszlet<>v_atl_mennyiseg + v_mennyiseg or cel_raktar_atlagar<>v_uj_atlagar or
                cel_raktar_ujkeszlet is null or cel_raktar_atlagar is null);
      end if;

      fetch c_forgalom
       into v_kod,
            v_forras_raktar_kod,
            v_cel_raktar_kod,
            v_mennyiseg,
            v_netto_osszeg_huf;
    end loop;

    close c_forgalom;

  return true;
end;'
  LANGUAGE plpgsql VOLATILE
  COST 100;
