CREATE TABLE folyamat_def_blokk
(
  kod serial NOT NULL,
  nev character varying(100) DEFAULT '',
  hossz integer DEFAULT 0,
  felelos_kod integer DEFAULT 0,
  CONSTRAINT folyamat_def_blokk_pkey PRIMARY KEY (kod)
)
WITHOUT OIDS;

CREATE INDEX folyamat_def_blokk_i1
  ON folyamat_def_blokk
  USING btree
  (nev);

CREATE TABLE folyamat_def_fej
(
  kod serial NOT NULL,
  nev character varying(100) DEFAULT '',
  felelos_kod integer DEFAULT 0,
  CONSTRAINT folyamat_def_fej_pkey PRIMARY KEY (kod)
)
WITHOUT OIDS;

CREATE INDEX folyamat_def_fej_i1
  ON folyamat_def_fej
  USING btree
  (nev);

CREATE TABLE folyamat_def
(
  kod serial NOT NULL,
  fej_kod integer DEFAULT 0,
  blokk_no integer DEFAULT 0,
  blokk_kod integer DEFAULT 0,
  felelos_kod integer DEFAULT 0,
  hossz integer DEFAULT 0,
  CONSTRAINT folyamat_def_pkey PRIMARY KEY (kod),
  CONSTRAINT folyamat_def_fk1 FOREIGN KEY (fej_kod)
      REFERENCES folyamat_def_fej (kod) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE
)
WITHOUT OIDS;

CREATE INDEX folyamat_def_i1
  ON folyamat_def
  USING btree
  (fej_kod);