CREATE OR REPLACE FUNCTION tr_raktar_mozgas_atlagar()
  RETURNS trigger AS
$BODY$declare

  v_atl_mennyiseg     tetel_raktar.atl_mennyiseg%type;
  v_atl_atlagar       tetel_raktar.atl_atlagar%type;
  v_uj_atlagar        tetel_raktar.atl_atlagar%type;
  v_netto_osszeg_huf  raktar_mozgas.netto_osszeg_huf%type;
  v_partner_kod       raktar_mozgas_fej.partner_kod%type;
  v_db                integer;
  v_foglalt           real;
  v_foglalt_valtozas  real;
  v_rendelt           real;
  v_rendelt_valtozas  real;
begin
  -- Ha nem keszletet mozgatunk, akkor semmit sem kell tenni
  if new.csak_fobizonylat_tetel = '1' then
     if new.tetel_tipus = '0' then
        select utolsobeszerzesiar
          into v_atl_atlagar
          from tetel
         where kod = new.tetel_kod;
        new.forras_raktar_atlagar:=v_atl_atlagar;
     end if;
     return new;
  end if;

  -- Foglalas
  IF new.csak_fobizonylat_tetel = '2' THEN
     IF new.tetel_tipus = '1' THEN
        IF new.forras_raktar_kod<>0 THEN
           SELECT partner_kod
             INTO v_partner_kod
             FROM raktar_mozgas_fej
             WHERE kod = new.fej_kod;
             
           UPDATE tetel_raktar
             SET foglalt = foglalt + new.mennyiseg,
                 szabad = keszlet - new.mennyiseg - foglalt
             WHERE raktar_kod = new.forras_raktar_kod
               AND tetel_kod = new.tetel_kod;

           SELECT count(*)
             INTO v_db
             FROM tetel_foglalas
            WHERE partner_kod = v_partner_kod
              AND raktar_kod = new.forras_raktar_kod
              AND tetel_kod = new.tetel_kod;   

           IF v_db = 0 THEN
              INSERT INTO tetel_foglalas (partner_kod,raktar_kod,tetel_kod,foglalt) VALUES
                                         (v_partner_kod,new.forras_raktar_kod,new.tetel_kod,new.mennyiseg);
           ELSE
              UPDATE tetel_foglalas
                 SET foglalt = foglalt + new.mennyiseg
               WHERE partner_kod = v_partner_kod
                 AND raktar_kod = new.forras_raktar_kod
                 AND tetel_kod = new.tetel_kod;             
           END IF;             
        END IF;
     END IF;
     RETURN new;
  END IF;

 -- Rendels
  IF new.csak_fobizonylat_tetel = '3' THEN
     IF (new.tetel_tipus <> '0') AND (new.tetel_tipus <> '8') THEN
        IF new.forras_raktar_kod<>0 THEN
           SELECT partner_kod
             INTO v_partner_kod
             FROM raktar_mozgas_fej
             WHERE kod = new.fej_kod;
             
           UPDATE tetel_raktar
             SET rendelt = rendelt + new.mennyiseg
             WHERE raktar_kod = new.forras_raktar_kod
               AND tetel_kod = new.tetel_kod;

           SELECT count(*)
             INTO v_db
             FROM tetel_rendeles
            WHERE partner_kod = v_partner_kod
              AND raktar_kod = new.forras_raktar_kod
              AND tetel_kod = new.tetel_kod;   

           IF v_db = 0 THEN
              INSERT INTO tetel_rendeles (partner_kod,raktar_kod,tetel_kod,rendelt) VALUES
                                         (v_partner_kod,new.forras_raktar_kod,new.tetel_kod,new.mennyiseg);
           ELSE
              UPDATE tetel_rendeles
                 SET rendelt = rendelt + new.mennyiseg
               WHERE partner_kod = v_partner_kod
                 AND raktar_kod = new.forras_raktar_kod
                 AND tetel_kod = new.tetel_kod;             
           END IF;             
        END IF;
     END IF;
     RETURN new;
  END IF;  

  -- Keszletet erinto mozgas

  if new.forras_raktar_kod<>0 then

     if new.cel_raktar_kod=0 then -- visszaigazolt tetel kiszallitasa
        SELECT partner_kod
          INTO v_partner_kod
          FROM raktar_mozgas_fej
         WHERE kod = new.fej_kod;

        SELECT foglalt
          INTO v_foglalt
          FROM tetel_foglalas
         WHERE partner_kod = v_partner_kod
           AND raktar_kod = new.forras_raktar_kod
           AND tetel_kod = new.tetel_kod;   


         IF (v_foglalt <> 0) THEN
            IF (new.mennyiseg > v_foglalt) THEN 
               v_foglalt_valtozas := v_foglalt;
            ELSE
               v_foglalt_valtozas := new.mennyiseg;
            END IF;

            UPDATE tetel_foglalas
               SET foglalt = foglalt - v_foglalt_valtozas
             WHERE partner_kod = v_partner_kod
               AND raktar_kod = new.forras_raktar_kod
               AND tetel_kod = new.tetel_kod;

	    UPDATE tetel_raktar
	       SET foglalt = foglalt - v_foglalt_valtozas, szabad = keszlet - v_foglalt_valtozas - foglalt
	     WHERE raktar_kod = new.forras_raktar_kod AND tetel_kod = new.tetel_kod;               
         END IF;

     end if;

     update tetel_raktar
        set keszlet = keszlet - new.mennyiseg,
            szabad = keszlet - new.mennyiseg - foglalt,
            atl_mennyiseg = atl_mennyiseg - new.mennyiseg
      where raktar_kod = new.forras_raktar_kod
        and tetel_kod = new.tetel_kod;

     select atl_mennyiseg,
            atl_atlagar
       into v_atl_mennyiseg,
            v_atl_atlagar
       from tetel_raktar
      where raktar_kod = new.forras_raktar_kod
        and tetel_kod = new.tetel_kod;

     new.forras_raktar_ujkeszlet:=v_atl_mennyiseg;
     new.forras_raktar_atlagar:=v_atl_atlagar;
  end if;

  if new.cel_raktar_kod<>0 then

     if new.forras_raktar_kod=0 then -- rendelesre erkezo tetel bevetelezese
        SELECT partner_kod
          INTO v_partner_kod
          FROM raktar_mozgas_fej
         WHERE kod = new.fej_kod;

        SELECT rendelt
          INTO v_rendelt
          FROM tetel_rendeles
         WHERE partner_kod = v_partner_kod
           AND raktar_kod = new.cel_raktar_kod
           AND tetel_kod = new.tetel_kod;   

         IF (v_rendelt <> 0) THEN
            IF (new.mennyiseg > v_rendelt) THEN 
               v_rendelt_valtozas := v_rendelt;
            ELSE
               v_rendelt_valtozas := new.mennyiseg;
            END IF;

            UPDATE tetel_rendeles
               SET rendelt = rendelt - v_rendelt_valtozas
             WHERE partner_kod = v_partner_kod
               AND raktar_kod = new.cel_raktar_kod
               AND tetel_kod = new.tetel_kod;             

            UPDATE tetel_raktar
	       SET rendelt = rendelt - v_rendelt_valtozas
	     WHERE raktar_kod = new.cel_raktar_kod 
	       AND tetel_kod = new.tetel_kod;
         END IF;

     end if;
        
     v_netto_osszeg_huf:=new.netto_osszeg_huf;

     if v_netto_osszeg_huf = 0 then
           
        select atl_atlagar * new.mennyiseg
          into v_netto_osszeg_huf
          from tetel_raktar
         where raktar_kod = new.forras_raktar_kod
           and tetel_kod = new.tetel_kod;
     end if;

     select atl_mennyiseg,
            atl_atlagar
       into v_atl_mennyiseg,
            v_atl_atlagar
       from tetel_raktar
      where raktar_kod = new.cel_raktar_kod
        and tetel_kod = new.tetel_kod;

     if v_atl_mennyiseg + new.mennyiseg<>0 then
        v_uj_atlagar:=((v_atl_mennyiseg * v_atl_atlagar) + v_netto_osszeg_huf) / (v_atl_mennyiseg + new.mennyiseg);
     else
        -- v_uj_atlagar:=0;
     end if;

     update tetel_raktar
        set keszlet = keszlet + new.mennyiseg,
            szabad = keszlet + new.mennyiseg - foglalt,
            atl_mennyiseg = atl_mennyiseg + new.mennyiseg,
            atl_atlagar = v_uj_atlagar
      where raktar_kod = new.cel_raktar_kod
        and tetel_kod = new.tetel_kod;

     new.cel_raktar_ujkeszlet:=v_atl_mennyiseg + new.mennyiseg;
     new.cel_raktar_atlagar:=v_uj_atlagar;
    
  end if;

  return new;
end;$BODY$
  LANGUAGE plpgsql VOLATILE;