CREATE OR REPLACE FUNCTION _get_legnagyobb_ert_menny_min_alkalommal(
    v_raktar_kod integer,
    v_tetel_kod integer,
    v_datum1 date,
    v_datum2 date,
    v_min_alkalom integer)
  RETURNS double precision AS
'declare

v_eredmeny float8;

begin
   SELECT mennyiseg INTO v_eredmeny
        FROM raktar_mozgas, raktar_mozgas_fej
        WHERE raktar_mozgas.fej_kod = raktar_mozgas_fej.kod
          and raktar_mozgas.forras_raktar_kod = v_raktar_kod
          and raktar_mozgas.csak_fobizonylat_tetel = 0
          and raktar_mozgas.mennyiseg > 0
          and raktar_mozgas.tetel_kod = v_tetel_kod
          and raktar_mozgas.netto_arbevetel <> 0          
          and raktar_mozgas_fej.datum >= v_datum1
          and raktar_mozgas_fej.datum <= v_datum2
        GROUP BY 1 HAVING COUNT(*) >= v_min_alkalom ORDER BY 1 DESC LIMIT 1;           
   
   return v_eredmeny;
end;
'
  LANGUAGE plpgsql VOLATILE
  COST 100;